/*
 * 创客交易日汇总
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Data;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserTradeDaySummaryController : BaseController
    {
        public UserTradeDaySummaryController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客交易日汇总列表

        /// <summary>
        /// 根据条件查询创客交易日汇总列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(TradeDaySummary data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;
            return View();
        }

        #endregion

        #region 根据条件查询创客交易日汇总列表

        /// <summary>
        /// 创客交易日汇总列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(TradeDaySummary data, string MakerCode, string RealName, string TradeMonthSelect, string TradeDateSelect, string BrandId, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            // //产品类型
            if (!string.IsNullOrEmpty(BrandId))
            {
                condition += " and BrandId ='" + BrandId + "'";
            }
            //交易月份
            if (!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }
            else
            {
                var start = DateTime.Now.AddMonths(-1).ToString("yyyyMM");
                condition += " and TradeMonth>=" + start;
            }
            //交易日期
            if (!string.IsNullOrEmpty(TradeDateSelect))
            {
                string[] datelist = TradeDateSelect.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0].Replace("-", "");
                string end = datelist[1].Replace("-", "");
                condition += " and TradeDate>=" + start + " and TradeDate<=" + end + "";
            }
            else
            {
                var start = DateTime.Now.AddMonths(-1).ToString("yyyyMM");
                condition += " and TradeMonth>=" + start;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TradeDaySummary", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
            }
            Dictionary<string, object> other = new Dictionary<string, object>();
            string HelpDirectTradeAmt = "0.00"; //扶持期直营贷记卡交易
            string NotHelpDirectTradeAmt = "0.00"; //稳定期直营贷记卡交易
            string ProfitDirectCreditTradeAmt = "0.00"; //盈利期直营贷记卡交易
            string HelpDirectDebitTradeAmt = "0.00"; //扶持期直营借记卡交易
            string NotHelpDirectDebitTradeAmt = "0.00"; //稳定期直营借记卡交易
            string ProfitDirectDebitTradeAmt = "0.00"; //盈利期直营借记卡交易

            string HelpNonDirectTradeAmt = "0.00"; //扶持期非直营贷记卡交易
            string NotHelpNonDirectTradeAmt = "0.00"; //稳定期非直营贷记卡交易
            string ProfitNonDirectCreditTradeAmt = "0.00"; //盈利期非直营贷记卡交易
            string HelpNonDirectDebitTradeAmt = "0.00"; //扶持期非直营借记卡交易
            string NotHelpNonDirectDebitTradeAmt = "0.00"; //稳定期非直营借记卡交易
            string ProfitNonDirectDebitTradeAmt = "0.00"; //盈利期非直营借记卡交易

            DataTable dt = OtherMySqlConn.dtable("select sum(HelpDirectTradeAmt),sum(NotHelpDirectTradeAmt),sum(ProfitDirectCreditTradeAmt),sum(HelpDirectDebitTradeAmt),sum(NotHelpDirectDebitTradeAmt),sum(ProfitDirectDebitTradeAmt) from TradeDaySummary where SeoTitle='self' " + condition);
            if (dt.Rows.Count > 0)
            {
                HelpDirectTradeAmt = dt.Rows[0][0].ToString();
                NotHelpDirectTradeAmt = dt.Rows[0][1].ToString();
                ProfitDirectCreditTradeAmt = dt.Rows[0][2].ToString();
                HelpDirectDebitTradeAmt = dt.Rows[0][3].ToString();
                NotHelpDirectDebitTradeAmt = dt.Rows[0][4].ToString();
                ProfitDirectDebitTradeAmt = dt.Rows[0][5].ToString();
            }
            dt = OtherMySqlConn.dtable("select sum(HelpNonDirectTradeAmt),sum(NotHelpNonDirectTradeAmt),sum(ProfitNonDirectCreditTradeAmt),sum(HelpNonDirectDebitTradeAmt),sum(NotHelpNonDirectDebitTradeAmt),sum(ProfitNonDirectDebitTradeAmt) from TradeDaySummary where SeoTitle='team' " + condition);
            if (dt.Rows.Count > 0)
            {
                HelpNonDirectTradeAmt = dt.Rows[0][0].ToString();
                NotHelpNonDirectTradeAmt = dt.Rows[0][1].ToString();
                ProfitNonDirectCreditTradeAmt = dt.Rows[0][2].ToString();
                HelpNonDirectDebitTradeAmt = dt.Rows[0][3].ToString();
                NotHelpNonDirectDebitTradeAmt = dt.Rows[0][4].ToString();
                ProfitNonDirectDebitTradeAmt = dt.Rows[0][5].ToString();
            }
            other.Add("HelpDirectTradeAmt", HelpDirectTradeAmt);
            other.Add("NotHelpDirectTradeAmt", NotHelpDirectTradeAmt);
            other.Add("ProfitDirectCreditTradeAmt", ProfitDirectCreditTradeAmt);
            other.Add("HelpDirectDebitTradeAmt", HelpDirectDebitTradeAmt);
            other.Add("NotHelpDirectDebitTradeAmt", NotHelpDirectDebitTradeAmt);
            other.Add("ProfitDirectDebitTradeAmt", ProfitDirectDebitTradeAmt);
            other.Add("HelpNonDirectTradeAmt", HelpNonDirectTradeAmt);
            other.Add("NotHelpNonDirectTradeAmt", NotHelpNonDirectTradeAmt);
            other.Add("ProfitNonDirectCreditTradeAmt", ProfitNonDirectCreditTradeAmt);
            other.Add("HelpNonDirectDebitTradeAmt", HelpNonDirectDebitTradeAmt);
            other.Add("NotHelpNonDirectDebitTradeAmt", NotHelpNonDirectDebitTradeAmt);
            other.Add("ProfitNonDirectDebitTradeAmt", ProfitNonDirectDebitTradeAmt);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加创客交易日汇总

        /// <summary>
        /// 增加或修改创客交易日汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客交易日汇总

        /// <summary>
        /// 增加或修改创客交易日汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(TradeDaySummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("TradeDaySummary", Fields, 0);
            AddSysLog(data.Id.ToString(), "TradeDaySummary", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客交易日汇总

        /// <summary>
        /// 增加或修改创客交易日汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            TradeDaySummary editData = db.TradeDaySummary.FirstOrDefault(m => m.Id == Id) ?? new TradeDaySummary();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客交易日汇总

        /// <summary>
        /// 增加或修改创客交易日汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(TradeDaySummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TradeDaySummary", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "TradeDaySummary", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客交易日汇总信息

        /// <summary>
        /// 删除创客交易日汇总信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TradeDaySummary", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TradeDaySummary", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TradeDaySummary", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TradeDaySummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TradeDaySummary", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TradeDaySummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("TradeDaySummary", Sort, Id);

            AddSysLog(Id.ToString(), "TradeDaySummary", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.TradeDaySummary.Add(new TradeDaySummary()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "TradeDaySummary", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(TradeDaySummary data, string MakerCode, string RealName, string TradeMonthSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //交易日期
            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //交易月份
            if (!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TradeDaySummary", Fields, "Id desc", "0", 1, 20000, condition, "UserId,TradeDate,TradeMonth,BrandId,HelpDirectTradeAmt,NotHelpDirectTradeAmt,HelpDirectDebitTradeAmt,NotHelpDirectDebitTradeAmt,HelpNonDirectTradeAmt,NotHelpNonDirectTradeAmt,HelpNonDirectDebitTradeAmt,NotHelpNonDirectDebitTradeAmt,SeoTitle", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                dic.Remove("UserId");
                dic["SeoTitle"] = dic["SeoTitle"].ToString() == "self" ? "直营" : "非直营";
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("TradeDate", "交易日");
            ReturnFields.Add("TradeMonth", "交易月");
            ReturnFields.Add("BrandId", "品牌");
            ReturnFields.Add("SeoTitle", "交易类型");
            ReturnFields.Add("HelpDirectTradeAmt", "扶持期直营贷记卡交易");
            ReturnFields.Add("NotHelpDirectTradeAmt", "稳定期直营贷记卡交易");
            ReturnFields.Add("ProfitDirectCreditTradeAmt", "盈利期直营贷记卡交易");
            ReturnFields.Add("HelpDirectDebitTradeAmt", "扶持期直营借记卡交易");
            ReturnFields.Add("NotHelpDirectDebitTradeAmt", "稳定期直营借记卡交易");
            ReturnFields.Add("ProfitDirectDebitTradeAmt", "盈利期直营借记卡交易");
            ReturnFields.Add("HelpNonDirectTradeAmt", "扶持期非直营贷记卡交易");
            ReturnFields.Add("NotHelpNonDirectTradeAmt", "稳定期非直营贷记卡交易");
            ReturnFields.Add("ProfitNonDirectCreditTradeAmt", "盈利期非直营贷记卡交易");
            ReturnFields.Add("HelpNonDirectDebitTradeAmt", "扶持期非直营借记卡交易");
            ReturnFields.Add("NotHelpNonDirectDebitTradeAmt", "稳定期非直营借记卡交易");
            ReturnFields.Add("ProfitNonDirectDebitTradeAmt", "盈利期非直营借记卡交易");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "TradeDaySummary", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
